#pragma once

#include "ActorInterface.h"
#include "WASCommand.h"
#include "WASActor.h"

class CWASListTenantDomain : public CWASCommand
{
public:
	CWASListTenantDomain(CWASActor *pActor);
	~CWASListTenantDomain(void);

	void ExecuteAsync(void);

	void SetParameter(LPCWSTR strTenant)
	{
		m_strTenant = strTenant;
	}

private:
	bool ParseAndEventFire(nfc::CIkXMLDom * pDom);

protected:
	// override in drived class
	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		nfc::CIkXMLDom * /*pDom*/);

	virtual void OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/);

private:
	std::wstring m_strTenant;
	std::vector<GT_TENANT_DOMAIN_DATA> m_listDomain;
};
